
Ruby - Feature #5458

DL should be removed 

10/18/2011 04:08 AM - kosaki (Motohiro KOSAKI)

Status: Closed   

Priority: Normal   

Assignee: tenderlovemaking (Aaron Patterson)   

Target version: 2.2.0   

Description

DL and fiddle are redundant. Moreover DL has no maintainer and its code is problematic.

Related issues:

Related to Ruby - Feature #8601: Win32API.rb long life plan Closed

Related to Ruby - Misc #10553: Ruby 2.2.0 release engeneering Closed

Blocks Ruby - Bug #6592: test_call_double(DL::TestDL) fails on ARM HardFP Closed 06/14/2012

Associated revisions

Revision 07308c4d30b8c5260e5366c8eed2abf054d86fe7 - 10/31/2014 09:13 PM - tenderlovemaking (Aaron Patterson)

ext/dl/*: remove DL as it is replaced by Fiddle.

[Feature #5458] Thanks to Jonan Scheffler jonanscheffler@gmail.com

for this patch

test/dl/*: ditto.

git-svn-id: svn+ssh://ci.ruby-lang.org/ruby/trunk@48217 b2dd03c8-39d4-4d8f-98ff-823fe69b080e

Revision 07308c4d - 10/31/2014 09:13 PM - tenderlovemaking (Aaron Patterson)

ext/dl/*: remove DL as it is replaced by Fiddle.

[Feature #5458] Thanks to Jonan Scheffler jonanscheffler@gmail.com

for this patch

test/dl/*: ditto.

git-svn-id: svn+ssh://ci.ruby-lang.org/ruby/trunk@48217 b2dd03c8-39d4-4d8f-98ff-823fe69b080e

History

#1 - 10/23/2011 05:21 PM - naruse (Yui NARUSE)

- Project changed from 14 to Ruby

#2 - 03/27/2012 10:49 PM - mame (Yusuke Endoh)

- Target version set to 3.0

#3 - 03/27/2012 10:50 PM - mame (Yusuke Endoh)

- Status changed from Open to Assigned

- Assignee set to matz (Yukihiro Matsumoto)

In principle, nothing should be removed from 2.0 because of compatibility.

I cannot advocate DL and Syck, though...

--

Yusuke Endoh mame@tsg.ne.jp
#4 - 03/28/2012 06:59 AM - Anonymous

- File noname added

On Tue, Mar 27, 2012 at 10:50:41PM +0900, mame (Yusuke Endoh) wrote:

Issue #5458 has been updated by mame (Yusuke Endoh).

Status changed from Open to Assigned

Assignee set to matz (Yukihiro Matsumoto)

In principle, nothing should be removed from 2.0 because of compatibility.

I cannot advocate DL and Syck, though...

 Fiddle doesn't handle struct creation and formatting.  That part of DL

is useful.  I could port that to Fiddle, but I'm not sure why.

Now that libffi will work with windows, why don't we just remove the C

code that backs DL?  Then we can keep the DL ruby code and forget about

the native code.

--

Aaron Patterson

http://tenderlovemaking.com/

#5 - 04/28/2012 01:51 AM - matz (Yukihiro Matsumoto)

- Assignee changed from matz (Yukihiro Matsumoto) to mame (Yusuke Endoh)

Even though DL can be emulated by using Fiddle in theory, I'd rather keep it for 2.0 for compatibility.

After 2.0, it's OK to replace DL.  In that case, we can mark DL as obsolete.

#6 - 04/28/2012 02:06 AM - mame (Yusuke Endoh)

- Assignee changed from mame (Yusuke Endoh) to tenderlovemaking (Aaron Patterson)

- Target version changed from 3.0 to 2.0.0

Okay, I'm willing to mark DL as obsolete in 2.0.

If anyone has an objection, please declare yourself ASAP.

Aaron, could you add a warning?

Then, please reassign back to me.

--

Yusuke Endoh mame@tsg.ne.jp

#7 - 04/28/2012 05:53 AM - Anonymous

- File noname added

On Sat, Apr 28, 2012 at 02:06:51AM +0900, mame (Yusuke Endoh) wrote:

Issue #5458 has been updated by mame (Yusuke Endoh).

Assignee changed from mame (Yusuke Endoh) to tenderlovemaking (Aaron Patterson)

Target version changed from 3.0 to 2.0.0

Okay, I'm willing to mark DL as obsolete in 2.0.

If anyone has an objection, please declare yourself ASAP.

Aaron, could you add a warning?

Then, please reassign back to me.

 Yes I can add a warning! :-)

--

Aaron Patterson

http://tenderlovemaking.com/

#8 - 05/04/2012 09:28 PM - naruse (Yui NARUSE)
- File deleted (noname)

#9 - 05/04/2012 09:28 PM - naruse (Yui NARUSE)

- File deleted (noname)

#10 - 11/20/2012 10:39 PM - mame (Yusuke Endoh)

Aaron, did you add a warning?

--

Yusuke Endoh mame@tsg.ne.jp

#11 - 11/24/2012 11:26 AM - mame (Yusuke Endoh)

Aaron?

--

Yusuke Endoh mame@tsg.ne.jp

#12 - 11/27/2012 10:53 AM - Anonymous

On Sat, Nov 24, 2012 at 11:26:16AM +0900, mame (Yusuke Endoh) wrote:

Issue #5458 has been updated by mame (Yusuke Endoh).

Aaron?

 Sorry, I'm working on this.  I should have the deprecation warning added

some time tomorrow (UTC-7).

--

Aaron Patterson

http://tenderlovemaking.com/

#13 - 11/28/2012 03:14 AM - zzak (zzak _)

I wrote a patch for the deprecation notice: https://gist.github.com/4155983

#14 - 11/29/2012 02:30 AM - tenderlovemaking (Aaron Patterson)

- Assignee changed from tenderlovemaking (Aaron Patterson) to mame (Yusuke Endoh)

DL is deprecated in trunk.  To maintain backwards compatibility, I've moved some parts of DL to Fiddle.  We should be able to remove ext/dl after 2.0

release.

#15 - 12/01/2012 11:57 PM - sorah (Sorah Fukumori)

- Category set to ext

- Target version changed from 2.0.0 to 2.6

#16 - 05/16/2013 11:28 AM - ngoto (Naohisa Goto)

When DL is removed?

#17 - 05/16/2013 11:38 AM - sikachu (Prem Sichanugrist)

@ngoto (Naohisa Goto) Looking from the target, seems like this will be removed on 2.1.0 (next minor)

#18 - 05/16/2013 07:20 PM - ngoto (Naohisa Goto)

- Target version changed from 2.6 to 2.1.0

#19 - 05/20/2013 03:32 AM - luislavena (Luis Lavena)

tenderlovemaking (Aaron Patterson) wrote:

DL is deprecated in trunk.  To maintain backwards compatibility, I've moved some parts of DL to Fiddle.  We should be able to remove ext/dl

after 2.0 release.

 What parts of DL remain to be migrated to Fiddle?
With DL being deprecated, Win32API component and win32/registry will need to be changed or removed entirely.

#20 - 05/20/2013 07:59 AM - zzak (zzak _)

The Win32 stuff is largely undocumented, but I remember ngoto-san

moved a lot of it to Fiddle already?

#21 - 05/21/2013 07:53 AM - Anonymous

On Mon, May 20, 2013 at 07:55:11AM +0900, Zachary Scott wrote:

The Win32 stuff is largely undocumented, but I remember ngoto-san

moved a lot of it to Fiddle already?

 Pretty much everything should be moved by now.  I'll remove DL, see what

breaks, then port any remaining bits.

--

Aaron Patterson

http://tenderlovemaking.com/

#22 - 05/22/2013 12:26 AM - luislavena (Luis Lavena)

zzak (Zachary Scott) wrote:

The Win32 stuff is largely undocumented, but I remember ngoto-san

moved a lot of it to Fiddle already?

 I think you're correct, I see win32/registry and win32/resolv:

However I don't see Win32API:

https://github.com/ruby/ruby/blob/trunk/ext/dl/win32/lib/Win32API.rb

So I think the warning in 1.9.3 and 2.0.0 is misleading.

Thank you.

#23 - 01/28/2014 06:01 AM - zzak (zzak _)

It seems the win32 stuff was moved in r41936 and released in 2.1.0: https://github.com/ruby/ruby/commit/771d31a

Should we mark this ticket as closed 100%?

#24 - 01/30/2014 06:16 AM - hsbt (Hiroshi SHIBATA)

- Target version changed from 2.1.0 to 2.2.0

#25 - 07/01/2014 06:45 AM - ngoto (Naohisa Goto)

- Related to Feature #8601: Win32API.rb long life plan added

#26 - 10/13/2014 10:22 AM - hsbt (Hiroshi SHIBATA)

- Assignee changed from mame (Yusuke Endoh) to tenderlovemaking (Aaron Patterson)

Hi, tenderlove.

Please remove DL from trunk.

#27 - 10/31/2014 09:13 PM - Anonymous

- Status changed from Assigned to Closed

- % Done changed from 0 to 100

Applied in changeset r48217.

ext/dl/*: remove DL as it is replaced by Fiddle.

[Feature #5458] Thanks to Jonan Scheffler jonanscheffler@gmail.com

for this patch
test/dl/*: ditto.

#28 - 11/10/2014 04:19 PM - vo.x (Vit Ondruch)

- Blocks Bug #6592: test_call_double(DL::TestDL) fails on ARM HardFP added

#29 - 12/19/2014 02:41 AM - naruse (Yui NARUSE)

- Status changed from Closed to Assigned

As far as I understand, removal of ext/dl is done only if Ruby bundle libffi source like libyaml.

But libffi source is not bundled yet.

I'll revert r48217 soon.

#30 - 12/19/2014 02:46 AM - naruse (Yui NARUSE)

- Related to Misc #10553: Ruby 2.2.0 release engeneering added

#31 - 12/19/2014 11:03 AM - vo.x (Vit Ondruch)

What would be the point of revet? Does Ruby need to bundle everything now? It is not the case for zlib, tcl/tk nor for OpenSSL, so why should Ruby

bundle libffi? So to say, this is -1 for reverting r48217 and -1 for bundling libffi.

#32 - 12/19/2014 11:20 AM - usa (Usaku NAKAMURA)

Vit Ondruch wrote:

What would be the point of revet?

 Because DL is stand alone but Fiddle is not.

To keep runnable some standard libraries, such as resolv.rb, we decided to bundle libffi if DL is removed.

#33 - 12/19/2014 06:00 PM - headius (Charles Nutter)

Well, DL depends on libdl, right?

Maybe we make it a default gem?

#34 - 12/19/2014 07:22 PM - nobu (Nobuyoshi Nakada)

Charles Nutter wrote:

Well, DL depends on libdl, right?

 Yes on some platforms, no on others.

Usually dlopen() is a part of system-provided features, regardless of the library to be linked.

And different APIs are used on Windows, of course.

Maybe we make it a default gem?

 One of the main problems is Win32API.

It's used very often.

#35 - 01/08/2015 01:36 PM - hsbt (Hiroshi SHIBATA)

- Status changed from Assigned to Closed

DL has been removed at Ruby 2.2.0
